//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocailShare_Forum_MessagesBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocailShare_Forum_MessagesBLL() : this(new SocialShareDatabaseContext()) { }

        public SocailShare_Forum_MessagesBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocailShare_Forum_MessagesSaving(SocailShare_Forum_Messages socailShare_Forum_Messages);

        partial void OnSocailShare_Forum_MessagesCreating(SocailShare_Forum_Messages socailShare_Forum_Messages);
        partial void OnSocailShare_Forum_MessagesCreated(SocailShare_Forum_Messages socailShare_Forum_Messages);

        partial void OnSocailShare_Forum_MessagesUpdating(SocailShare_Forum_Messages socailShare_Forum_Messages);
        partial void OnSocailShare_Forum_MessagesUpdated(SocailShare_Forum_Messages socailShare_Forum_Messages);

        partial void OnSocailShare_Forum_MessagesSaved(SocailShare_Forum_Messages socailShare_Forum_Messages);

        partial void OnSocailShare_Forum_MessagesDeleting(SocailShare_Forum_Messages socailShare_Forum_Messages);
        partial void OnSocailShare_Forum_MessagesDeleted(SocailShare_Forum_Messages socailShare_Forum_Messages);


        #endregion

        #region Get Methods

        internal SocailShare_Forum_Messages GetSocailShare_Forum_MessagesByPostId(int postId)
        {
            //Validate Input
            if (postId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("postId"));
            
            return (_socialShareDatabaseContext.SocailShare_Forum_Messages.FirstOrDefault(socailShare_Forum_Messages => socailShare_Forum_Messages.PostId == postId));
        }
			
		        internal List<SocailShare_Forum_Messages> GetSocailShare_Forum_MessagesByCategoryId(int? categoryId)
        {
            //Validate Input
            if (categoryId.IsEmpty())
                return GetAllSocailShare_Forum_Messages();
 
            return (from socailShare_Forum_Messages in _socialShareDatabaseContext.SocailShare_Forum_Messages
                    where categoryId == null ? socailShare_Forum_Messages.CategoryId == null : socailShare_Forum_Messages.CategoryId == categoryId
                    select socailShare_Forum_Messages).ToList();
        }

        internal List<SocailShare_Forum_Messages> GetSocailShare_Forum_MessagesByCategoryIdPaged(int? categoryId, string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            //Validate Input
            if (categoryId.IsEmpty())
                return GetAllSocailShare_Forum_MessagesPaged(orderBy, startRowIndex, maximumRows);

            if (string.IsNullOrEmpty(orderBy))
                orderBy = "PostId";
            
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
				
            return (
                    from socailShare_Forum_Messages in
                        _socialShareDatabaseContext.SocailShare_Forum_Messages
                        .DynamicOrderBy(orderBy)
                    where categoryId == null ? socailShare_Forum_Messages.CategoryId == null : socailShare_Forum_Messages.CategoryId == categoryId
                    select socailShare_Forum_Messages
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocailShare_Forum_MessagesByCategoryId(int? categoryId, string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            //Validate Input
            if (categoryId.IsEmpty())
                return GetTotalCountForAllSocailShare_Forum_Messages(orderBy, startRowIndex, maximumRows);
			
            return _socialShareDatabaseContext.SocailShare_Forum_Messages.Count(socailShare_Forum_Messages => categoryId == null ? socailShare_Forum_Messages.CategoryId == null : socailShare_Forum_Messages.CategoryId == categoryId);
        }
			
				
        
        internal List<SocailShare_Forum_Messages> GetAllSocailShare_Forum_Messages()
        {
            return _socialShareDatabaseContext.SocailShare_Forum_Messages.ToList();
        }

        
        internal List<SocailShare_Forum_Messages> GetAllSocailShare_Forum_MessagesPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "PostId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socailShare_Forum_Messages in 
                        _socialShareDatabaseContext.SocailShare_Forum_Messages
                        .DynamicOrderBy(orderBy)
                    select socailShare_Forum_Messages
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocailShare_Forum_Messages(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocailShare_Forum_Messages.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocailShare_Forum_Messages(SocailShare_Forum_Messages newSocailShare_Forum_Messages)
        {
            // Validate Parameters
            if (newSocailShare_Forum_Messages == null)
                throw (new ArgumentNullException("newSocailShare_Forum_Messages"));

			/*
            
			// Validate Primary key value
            if (newSocailShare_Forum_Messages.PostId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocailShare_Forum_Messages"));
			*/
			
            // Apply business rules
            OnSocailShare_Forum_MessagesSaving(newSocailShare_Forum_Messages);
            OnSocailShare_Forum_MessagesCreating(newSocailShare_Forum_Messages);

            if (newSocailShare_Forum_Messages.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocailShare_Forum_Messages.Attach(newSocailShare_Forum_Messages);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocailShare_Forum_Messages, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socailShare_Forum_Messages created!");

            // Apply business workflow
            OnSocailShare_Forum_MessagesCreated(newSocailShare_Forum_Messages);
            OnSocailShare_Forum_MessagesSaved(newSocailShare_Forum_Messages);

            return newSocailShare_Forum_Messages.PostId;
        }

        
        internal void UpdateSocailShare_Forum_Messages(SocailShare_Forum_Messages updatedSocailShare_Forum_Messages)
        {
            // Validate Parameters
            if (updatedSocailShare_Forum_Messages == null)
                throw (new ArgumentNullException("updatedSocailShare_Forum_Messages"));

            // Validate Primary key value
            if (updatedSocailShare_Forum_Messages.PostId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocailShare_Forum_Messages"));

            // Apply business rules
            OnSocailShare_Forum_MessagesSaving(updatedSocailShare_Forum_Messages);
            OnSocailShare_Forum_MessagesUpdating(updatedSocailShare_Forum_Messages);

            //attaching and making ready for parsistance
            if (updatedSocailShare_Forum_Messages.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocailShare_Forum_Messages.Attach(updatedSocailShare_Forum_Messages);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocailShare_Forum_Messages, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socailShare_Forum_Messages updated!");

            //Apply business workflow
            OnSocailShare_Forum_MessagesUpdated(updatedSocailShare_Forum_Messages);
            OnSocailShare_Forum_MessagesSaved(updatedSocailShare_Forum_Messages);

        }

        
        internal void DeleteSocailShare_Forum_Messages(SocailShare_Forum_Messages socailShare_Forum_MessagesToBeDeleted)
        {
            //Validate Input
            if (socailShare_Forum_MessagesToBeDeleted == null)
                throw (new ArgumentNullException("socailShare_Forum_MessagesToBeDeleted"));

            // Validate Primary key value
            if (socailShare_Forum_MessagesToBeDeleted.PostId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socailShare_Forum_MessagesToBeDeleted"));

            OnSocailShare_Forum_MessagesSaving(socailShare_Forum_MessagesToBeDeleted);
            OnSocailShare_Forum_MessagesDeleting(socailShare_Forum_MessagesToBeDeleted);

            if (socailShare_Forum_MessagesToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocailShare_Forum_Messages.Attach(socailShare_Forum_MessagesToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socailShare_Forum_MessagesToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocailShare_Forum_Messages deleted!");
            
            OnSocailShare_Forum_MessagesDeleted(socailShare_Forum_MessagesToBeDeleted);
            OnSocailShare_Forum_MessagesSaved(socailShare_Forum_MessagesToBeDeleted);

        }

        internal void DeleteSocailShare_Forum_Messages(List<int> postIdsToDelete)
        {
            //Validate Input
            foreach (int postId in postIdsToDelete)
                if (postId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("postIdsToDelete"));

            List<SocailShare_Forum_Messages> socailShare_Forum_MessagessToBeDeleted = new List<SocailShare_Forum_Messages>();

            foreach (int postId in postIdsToDelete)
            {
                SocailShare_Forum_Messages socailShare_Forum_Messages = new SocailShare_Forum_Messages { PostId = postId };
                _socialShareDatabaseContext.SocailShare_Forum_Messages.Attach(socailShare_Forum_Messages);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socailShare_Forum_Messages, System.Data.EntityState.Deleted);
                socailShare_Forum_MessagessToBeDeleted.Add(socailShare_Forum_Messages);
                OnSocailShare_Forum_MessagesDeleting(socailShare_Forum_Messages);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != postIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socailShare_Forum_Messages records have not been deleted.");
            foreach (SocailShare_Forum_Messages socailShare_Forum_MessagesToBeDeleted in socailShare_Forum_MessagessToBeDeleted)
                OnSocailShare_Forum_MessagesDeleted(socailShare_Forum_MessagesToBeDeleted);
        }

        #endregion
	
	}
}
