//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocailShare_Site_ContentsBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocailShare_Site_ContentsBLL() : this(new SocialShareDatabaseContext()) { }

        public SocailShare_Site_ContentsBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocailShare_Site_ContentsSaving(SocailShare_Site_Contents socailShare_Site_Contents);

        partial void OnSocailShare_Site_ContentsCreating(SocailShare_Site_Contents socailShare_Site_Contents);
        partial void OnSocailShare_Site_ContentsCreated(SocailShare_Site_Contents socailShare_Site_Contents);

        partial void OnSocailShare_Site_ContentsUpdating(SocailShare_Site_Contents socailShare_Site_Contents);
        partial void OnSocailShare_Site_ContentsUpdated(SocailShare_Site_Contents socailShare_Site_Contents);

        partial void OnSocailShare_Site_ContentsSaved(SocailShare_Site_Contents socailShare_Site_Contents);

        partial void OnSocailShare_Site_ContentsDeleting(SocailShare_Site_Contents socailShare_Site_Contents);
        partial void OnSocailShare_Site_ContentsDeleted(SocailShare_Site_Contents socailShare_Site_Contents);


        #endregion

        #region Get Methods

        internal SocailShare_Site_Contents GetSocailShare_Site_ContentsByCmsId(int cmsId)
        {
            //Validate Input
            if (cmsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("cmsId"));
            
            return (_socialShareDatabaseContext.SocailShare_Site_Contents.FirstOrDefault(socailShare_Site_Contents => socailShare_Site_Contents.CmsId == cmsId));
        }
			
				
        
        internal List<SocailShare_Site_Contents> GetAllSocailShare_Site_Contents()
        {
            return _socialShareDatabaseContext.SocailShare_Site_Contents.ToList();
        }

        
        internal List<SocailShare_Site_Contents> GetAllSocailShare_Site_ContentsPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "CmsId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socailShare_Site_Contents in 
                        _socialShareDatabaseContext.SocailShare_Site_Contents
                        .DynamicOrderBy(orderBy)
                    select socailShare_Site_Contents
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocailShare_Site_Contents(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocailShare_Site_Contents.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocailShare_Site_Contents(SocailShare_Site_Contents newSocailShare_Site_Contents)
        {
            // Validate Parameters
            if (newSocailShare_Site_Contents == null)
                throw (new ArgumentNullException("newSocailShare_Site_Contents"));

			/*
            
			// Validate Primary key value
            if (newSocailShare_Site_Contents.CmsId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocailShare_Site_Contents"));
			*/
			
            // Apply business rules
            OnSocailShare_Site_ContentsSaving(newSocailShare_Site_Contents);
            OnSocailShare_Site_ContentsCreating(newSocailShare_Site_Contents);

            if (newSocailShare_Site_Contents.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocailShare_Site_Contents.Attach(newSocailShare_Site_Contents);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocailShare_Site_Contents, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socailShare_Site_Contents created!");

            // Apply business workflow
            OnSocailShare_Site_ContentsCreated(newSocailShare_Site_Contents);
            OnSocailShare_Site_ContentsSaved(newSocailShare_Site_Contents);

            return newSocailShare_Site_Contents.CmsId;
        }

        
        internal void UpdateSocailShare_Site_Contents(SocailShare_Site_Contents updatedSocailShare_Site_Contents)
        {
            // Validate Parameters
            if (updatedSocailShare_Site_Contents == null)
                throw (new ArgumentNullException("updatedSocailShare_Site_Contents"));

            // Validate Primary key value
            if (updatedSocailShare_Site_Contents.CmsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocailShare_Site_Contents"));

            // Apply business rules
            OnSocailShare_Site_ContentsSaving(updatedSocailShare_Site_Contents);
            OnSocailShare_Site_ContentsUpdating(updatedSocailShare_Site_Contents);

            //attaching and making ready for parsistance
            if (updatedSocailShare_Site_Contents.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocailShare_Site_Contents.Attach(updatedSocailShare_Site_Contents);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocailShare_Site_Contents, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socailShare_Site_Contents updated!");

            //Apply business workflow
            OnSocailShare_Site_ContentsUpdated(updatedSocailShare_Site_Contents);
            OnSocailShare_Site_ContentsSaved(updatedSocailShare_Site_Contents);

        }

        
        internal void DeleteSocailShare_Site_Contents(SocailShare_Site_Contents socailShare_Site_ContentsToBeDeleted)
        {
            //Validate Input
            if (socailShare_Site_ContentsToBeDeleted == null)
                throw (new ArgumentNullException("socailShare_Site_ContentsToBeDeleted"));

            // Validate Primary key value
            if (socailShare_Site_ContentsToBeDeleted.CmsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socailShare_Site_ContentsToBeDeleted"));

            OnSocailShare_Site_ContentsSaving(socailShare_Site_ContentsToBeDeleted);
            OnSocailShare_Site_ContentsDeleting(socailShare_Site_ContentsToBeDeleted);

            if (socailShare_Site_ContentsToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocailShare_Site_Contents.Attach(socailShare_Site_ContentsToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socailShare_Site_ContentsToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocailShare_Site_Contents deleted!");
            
            OnSocailShare_Site_ContentsDeleted(socailShare_Site_ContentsToBeDeleted);
            OnSocailShare_Site_ContentsSaved(socailShare_Site_ContentsToBeDeleted);

        }

        internal void DeleteSocailShare_Site_Contents(List<int> cmsIdsToDelete)
        {
            //Validate Input
            foreach (int cmsId in cmsIdsToDelete)
                if (cmsId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("cmsIdsToDelete"));

            List<SocailShare_Site_Contents> socailShare_Site_ContentssToBeDeleted = new List<SocailShare_Site_Contents>();

            foreach (int cmsId in cmsIdsToDelete)
            {
                SocailShare_Site_Contents socailShare_Site_Contents = new SocailShare_Site_Contents { CmsId = cmsId };
                _socialShareDatabaseContext.SocailShare_Site_Contents.Attach(socailShare_Site_Contents);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socailShare_Site_Contents, System.Data.EntityState.Deleted);
                socailShare_Site_ContentssToBeDeleted.Add(socailShare_Site_Contents);
                OnSocailShare_Site_ContentsDeleting(socailShare_Site_Contents);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != cmsIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socailShare_Site_Contents records have not been deleted.");
            foreach (SocailShare_Site_Contents socailShare_Site_ContentsToBeDeleted in socailShare_Site_ContentssToBeDeleted)
                OnSocailShare_Site_ContentsDeleted(socailShare_Site_ContentsToBeDeleted);
        }

        #endregion
	
	}
}
