//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_Admin_UsersBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_Admin_UsersBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_Admin_UsersBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_Admin_UsersSaving(SocialShare_Admin_Users socialShare_Admin_Users);

        partial void OnSocialShare_Admin_UsersCreating(SocialShare_Admin_Users socialShare_Admin_Users);
        partial void OnSocialShare_Admin_UsersCreated(SocialShare_Admin_Users socialShare_Admin_Users);

        partial void OnSocialShare_Admin_UsersUpdating(SocialShare_Admin_Users socialShare_Admin_Users);
        partial void OnSocialShare_Admin_UsersUpdated(SocialShare_Admin_Users socialShare_Admin_Users);

        partial void OnSocialShare_Admin_UsersSaved(SocialShare_Admin_Users socialShare_Admin_Users);

        partial void OnSocialShare_Admin_UsersDeleting(SocialShare_Admin_Users socialShare_Admin_Users);
        partial void OnSocialShare_Admin_UsersDeleted(SocialShare_Admin_Users socialShare_Admin_Users);


        #endregion

        #region Get Methods

        internal SocialShare_Admin_Users GetSocialShare_Admin_UsersByAdmin_User_Id(int admin_User_Id)
        {
            //Validate Input
            if (admin_User_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("admin_User_Id"));
            
            return (_socialShareDatabaseContext.SocialShare_Admin_Users.FirstOrDefault(socialShare_Admin_Users => socialShare_Admin_Users.Admin_User_Id == admin_User_Id));
        }
			
				
        
        internal List<SocialShare_Admin_Users> GetAllSocialShare_Admin_Users()
        {
            return _socialShareDatabaseContext.SocialShare_Admin_Users.ToList();
        }

        
        internal List<SocialShare_Admin_Users> GetAllSocialShare_Admin_UsersPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "Admin_User_Id";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_Admin_Users in 
                        _socialShareDatabaseContext.SocialShare_Admin_Users
                        .DynamicOrderBy(orderBy)
                    select socialShare_Admin_Users
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Admin_Users(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_Admin_Users.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_Admin_Users(SocialShare_Admin_Users newSocialShare_Admin_Users)
        {
            // Validate Parameters
            if (newSocialShare_Admin_Users == null)
                throw (new ArgumentNullException("newSocialShare_Admin_Users"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_Admin_Users.Admin_User_Id.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_Admin_Users"));
			*/
			
            // Apply business rules
            OnSocialShare_Admin_UsersSaving(newSocialShare_Admin_Users);
            OnSocialShare_Admin_UsersCreating(newSocialShare_Admin_Users);

            if (newSocialShare_Admin_Users.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Admin_Users.Attach(newSocialShare_Admin_Users);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_Admin_Users, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Admin_Users created!");

            // Apply business workflow
            OnSocialShare_Admin_UsersCreated(newSocialShare_Admin_Users);
            OnSocialShare_Admin_UsersSaved(newSocialShare_Admin_Users);

            return newSocialShare_Admin_Users.Admin_User_Id;
        }

        
        internal void UpdateSocialShare_Admin_Users(SocialShare_Admin_Users updatedSocialShare_Admin_Users)
        {
            // Validate Parameters
            if (updatedSocialShare_Admin_Users == null)
                throw (new ArgumentNullException("updatedSocialShare_Admin_Users"));

            // Validate Primary key value
            if (updatedSocialShare_Admin_Users.Admin_User_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_Admin_Users"));

            // Apply business rules
            OnSocialShare_Admin_UsersSaving(updatedSocialShare_Admin_Users);
            OnSocialShare_Admin_UsersUpdating(updatedSocialShare_Admin_Users);

            //attaching and making ready for parsistance
            if (updatedSocialShare_Admin_Users.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Admin_Users.Attach(updatedSocialShare_Admin_Users);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_Admin_Users, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Admin_Users updated!");

            //Apply business workflow
            OnSocialShare_Admin_UsersUpdated(updatedSocialShare_Admin_Users);
            OnSocialShare_Admin_UsersSaved(updatedSocialShare_Admin_Users);

        }

        
        internal void DeleteSocialShare_Admin_Users(SocialShare_Admin_Users socialShare_Admin_UsersToBeDeleted)
        {
            //Validate Input
            if (socialShare_Admin_UsersToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_Admin_UsersToBeDeleted"));

            // Validate Primary key value
            if (socialShare_Admin_UsersToBeDeleted.Admin_User_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_Admin_UsersToBeDeleted"));

            OnSocialShare_Admin_UsersSaving(socialShare_Admin_UsersToBeDeleted);
            OnSocialShare_Admin_UsersDeleting(socialShare_Admin_UsersToBeDeleted);

            if (socialShare_Admin_UsersToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_Admin_Users.Attach(socialShare_Admin_UsersToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Admin_UsersToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_Admin_Users deleted!");
            
            OnSocialShare_Admin_UsersDeleted(socialShare_Admin_UsersToBeDeleted);
            OnSocialShare_Admin_UsersSaved(socialShare_Admin_UsersToBeDeleted);

        }

        internal void DeleteSocialShare_Admin_Users(List<int> admin_User_IdsToDelete)
        {
            //Validate Input
            foreach (int admin_User_Id in admin_User_IdsToDelete)
                if (admin_User_Id.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("admin_User_IdsToDelete"));

            List<SocialShare_Admin_Users> socialShare_Admin_UserssToBeDeleted = new List<SocialShare_Admin_Users>();

            foreach (int admin_User_Id in admin_User_IdsToDelete)
            {
                SocialShare_Admin_Users socialShare_Admin_Users = new SocialShare_Admin_Users { Admin_User_Id = admin_User_Id };
                _socialShareDatabaseContext.SocialShare_Admin_Users.Attach(socialShare_Admin_Users);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Admin_Users, System.Data.EntityState.Deleted);
                socialShare_Admin_UserssToBeDeleted.Add(socialShare_Admin_Users);
                OnSocialShare_Admin_UsersDeleting(socialShare_Admin_Users);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != admin_User_IdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_Admin_Users records have not been deleted.");
            foreach (SocialShare_Admin_Users socialShare_Admin_UsersToBeDeleted in socialShare_Admin_UserssToBeDeleted)
                OnSocialShare_Admin_UsersDeleted(socialShare_Admin_UsersToBeDeleted);
        }

        #endregion
	
	}
}
