//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_Blog_CommentsBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_Blog_CommentsBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_Blog_CommentsBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_Blog_CommentsSaving(SocialShare_Blog_Comments socialShare_Blog_Comments);

        partial void OnSocialShare_Blog_CommentsCreating(SocialShare_Blog_Comments socialShare_Blog_Comments);
        partial void OnSocialShare_Blog_CommentsCreated(SocialShare_Blog_Comments socialShare_Blog_Comments);

        partial void OnSocialShare_Blog_CommentsUpdating(SocialShare_Blog_Comments socialShare_Blog_Comments);
        partial void OnSocialShare_Blog_CommentsUpdated(SocialShare_Blog_Comments socialShare_Blog_Comments);

        partial void OnSocialShare_Blog_CommentsSaved(SocialShare_Blog_Comments socialShare_Blog_Comments);

        partial void OnSocialShare_Blog_CommentsDeleting(SocialShare_Blog_Comments socialShare_Blog_Comments);
        partial void OnSocialShare_Blog_CommentsDeleted(SocialShare_Blog_Comments socialShare_Blog_Comments);


        #endregion

        #region Get Methods

        internal SocialShare_Blog_Comments GetSocialShare_Blog_CommentsByCommentsId(int commentsId)
        {
            //Validate Input
            if (commentsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("commentsId"));
            
            return (_socialShareDatabaseContext.SocialShare_Blog_Comments.FirstOrDefault(socialShare_Blog_Comments => socialShare_Blog_Comments.CommentsId == commentsId));
        }
			
		        internal List<SocialShare_Blog_Comments> GetSocialShare_Blog_CommentsByBlogId(int blogId)
        {
            //Validate Input
            if (blogId.IsEmpty())
                return GetAllSocialShare_Blog_Comments();
 
            return (from socialShare_Blog_Comments in _socialShareDatabaseContext.SocialShare_Blog_Comments
                    where blogId == null ? socialShare_Blog_Comments.BlogId == null : socialShare_Blog_Comments.BlogId == blogId
                    select socialShare_Blog_Comments).ToList();
        }

        internal List<SocialShare_Blog_Comments> GetSocialShare_Blog_CommentsByBlogIdPaged(int blogId, string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            //Validate Input
            if (blogId.IsEmpty())
                return GetAllSocialShare_Blog_CommentsPaged(orderBy, startRowIndex, maximumRows);

            if (string.IsNullOrEmpty(orderBy))
                orderBy = "CommentsId";
            
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
				
            return (
                    from socialShare_Blog_Comments in
                        _socialShareDatabaseContext.SocialShare_Blog_Comments
                        .DynamicOrderBy(orderBy)
                    where blogId == null ? socialShare_Blog_Comments.BlogId == null : socialShare_Blog_Comments.BlogId == blogId
                    select socialShare_Blog_Comments
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Blog_CommentsByBlogId(int blogId, string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            //Validate Input
            if (blogId.IsEmpty())
                return GetTotalCountForAllSocialShare_Blog_Comments(orderBy, startRowIndex, maximumRows);
			
            return _socialShareDatabaseContext.SocialShare_Blog_Comments.Count(socialShare_Blog_Comments => blogId == null ? socialShare_Blog_Comments.BlogId == null : socialShare_Blog_Comments.BlogId == blogId);
        }
			
				
        
        internal List<SocialShare_Blog_Comments> GetAllSocialShare_Blog_Comments()
        {
            return _socialShareDatabaseContext.SocialShare_Blog_Comments.ToList();
        }

        
        internal List<SocialShare_Blog_Comments> GetAllSocialShare_Blog_CommentsPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "CommentsId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_Blog_Comments in 
                        _socialShareDatabaseContext.SocialShare_Blog_Comments
                        .DynamicOrderBy(orderBy)
                    select socialShare_Blog_Comments
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Blog_Comments(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_Blog_Comments.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_Blog_Comments(SocialShare_Blog_Comments newSocialShare_Blog_Comments)
        {
            // Validate Parameters
            if (newSocialShare_Blog_Comments == null)
                throw (new ArgumentNullException("newSocialShare_Blog_Comments"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_Blog_Comments.CommentsId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_Blog_Comments"));
			*/
			
            // Apply business rules
            OnSocialShare_Blog_CommentsSaving(newSocialShare_Blog_Comments);
            OnSocialShare_Blog_CommentsCreating(newSocialShare_Blog_Comments);

            if (newSocialShare_Blog_Comments.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Blog_Comments.Attach(newSocialShare_Blog_Comments);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_Blog_Comments, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Blog_Comments created!");

            // Apply business workflow
            OnSocialShare_Blog_CommentsCreated(newSocialShare_Blog_Comments);
            OnSocialShare_Blog_CommentsSaved(newSocialShare_Blog_Comments);

            return newSocialShare_Blog_Comments.CommentsId;
        }

        
        internal void UpdateSocialShare_Blog_Comments(SocialShare_Blog_Comments updatedSocialShare_Blog_Comments)
        {
            // Validate Parameters
            if (updatedSocialShare_Blog_Comments == null)
                throw (new ArgumentNullException("updatedSocialShare_Blog_Comments"));

            // Validate Primary key value
            if (updatedSocialShare_Blog_Comments.CommentsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_Blog_Comments"));

            // Apply business rules
            OnSocialShare_Blog_CommentsSaving(updatedSocialShare_Blog_Comments);
            OnSocialShare_Blog_CommentsUpdating(updatedSocialShare_Blog_Comments);

            //attaching and making ready for parsistance
            if (updatedSocialShare_Blog_Comments.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Blog_Comments.Attach(updatedSocialShare_Blog_Comments);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_Blog_Comments, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Blog_Comments updated!");

            //Apply business workflow
            OnSocialShare_Blog_CommentsUpdated(updatedSocialShare_Blog_Comments);
            OnSocialShare_Blog_CommentsSaved(updatedSocialShare_Blog_Comments);

        }

        
        internal void DeleteSocialShare_Blog_Comments(SocialShare_Blog_Comments socialShare_Blog_CommentsToBeDeleted)
        {
            //Validate Input
            if (socialShare_Blog_CommentsToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_Blog_CommentsToBeDeleted"));

            // Validate Primary key value
            if (socialShare_Blog_CommentsToBeDeleted.CommentsId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_Blog_CommentsToBeDeleted"));

            OnSocialShare_Blog_CommentsSaving(socialShare_Blog_CommentsToBeDeleted);
            OnSocialShare_Blog_CommentsDeleting(socialShare_Blog_CommentsToBeDeleted);

            if (socialShare_Blog_CommentsToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_Blog_Comments.Attach(socialShare_Blog_CommentsToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Blog_CommentsToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_Blog_Comments deleted!");
            
            OnSocialShare_Blog_CommentsDeleted(socialShare_Blog_CommentsToBeDeleted);
            OnSocialShare_Blog_CommentsSaved(socialShare_Blog_CommentsToBeDeleted);

        }

        internal void DeleteSocialShare_Blog_Comments(List<int> commentsIdsToDelete)
        {
            //Validate Input
            foreach (int commentsId in commentsIdsToDelete)
                if (commentsId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("commentsIdsToDelete"));

            List<SocialShare_Blog_Comments> socialShare_Blog_CommentssToBeDeleted = new List<SocialShare_Blog_Comments>();

            foreach (int commentsId in commentsIdsToDelete)
            {
                SocialShare_Blog_Comments socialShare_Blog_Comments = new SocialShare_Blog_Comments { CommentsId = commentsId };
                _socialShareDatabaseContext.SocialShare_Blog_Comments.Attach(socialShare_Blog_Comments);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Blog_Comments, System.Data.EntityState.Deleted);
                socialShare_Blog_CommentssToBeDeleted.Add(socialShare_Blog_Comments);
                OnSocialShare_Blog_CommentsDeleting(socialShare_Blog_Comments);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != commentsIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_Blog_Comments records have not been deleted.");
            foreach (SocialShare_Blog_Comments socialShare_Blog_CommentsToBeDeleted in socialShare_Blog_CommentssToBeDeleted)
                OnSocialShare_Blog_CommentsDeleted(socialShare_Blog_CommentsToBeDeleted);
        }

        #endregion
	
	}
}
