//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_BlogsBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_BlogsBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_BlogsBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_BlogsSaving(SocialShare_Blogs socialShare_Blogs);

        partial void OnSocialShare_BlogsCreating(SocialShare_Blogs socialShare_Blogs);
        partial void OnSocialShare_BlogsCreated(SocialShare_Blogs socialShare_Blogs);

        partial void OnSocialShare_BlogsUpdating(SocialShare_Blogs socialShare_Blogs);
        partial void OnSocialShare_BlogsUpdated(SocialShare_Blogs socialShare_Blogs);

        partial void OnSocialShare_BlogsSaved(SocialShare_Blogs socialShare_Blogs);

        partial void OnSocialShare_BlogsDeleting(SocialShare_Blogs socialShare_Blogs);
        partial void OnSocialShare_BlogsDeleted(SocialShare_Blogs socialShare_Blogs);


        #endregion

        #region Get Methods

        internal SocialShare_Blogs GetSocialShare_BlogsByBlogId(int blogId)
        {
            //Validate Input
            if (blogId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("blogId"));
            
            return (_socialShareDatabaseContext.SocialShare_Blogs.FirstOrDefault(socialShare_Blogs => socialShare_Blogs.BlogId == blogId));
        }
			
				
        
        internal List<SocialShare_Blogs> GetAllSocialShare_Blogs()
        {
            return _socialShareDatabaseContext.SocialShare_Blogs.ToList();
        }

        
        internal List<SocialShare_Blogs> GetAllSocialShare_BlogsPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "BlogId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_Blogs in 
                        _socialShareDatabaseContext.SocialShare_Blogs
                        .DynamicOrderBy(orderBy)
                    select socialShare_Blogs
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Blogs(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_Blogs.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_Blogs(SocialShare_Blogs newSocialShare_Blogs)
        {
            // Validate Parameters
            if (newSocialShare_Blogs == null)
                throw (new ArgumentNullException("newSocialShare_Blogs"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_Blogs.BlogId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_Blogs"));
			*/
			
            // Apply business rules
            OnSocialShare_BlogsSaving(newSocialShare_Blogs);
            OnSocialShare_BlogsCreating(newSocialShare_Blogs);

            if (newSocialShare_Blogs.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Blogs.Attach(newSocialShare_Blogs);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_Blogs, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Blogs created!");

            // Apply business workflow
            OnSocialShare_BlogsCreated(newSocialShare_Blogs);
            OnSocialShare_BlogsSaved(newSocialShare_Blogs);

            return newSocialShare_Blogs.BlogId;
        }

        
        internal void UpdateSocialShare_Blogs(SocialShare_Blogs updatedSocialShare_Blogs)
        {
            // Validate Parameters
            if (updatedSocialShare_Blogs == null)
                throw (new ArgumentNullException("updatedSocialShare_Blogs"));

            // Validate Primary key value
            if (updatedSocialShare_Blogs.BlogId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_Blogs"));

            // Apply business rules
            OnSocialShare_BlogsSaving(updatedSocialShare_Blogs);
            OnSocialShare_BlogsUpdating(updatedSocialShare_Blogs);

            //attaching and making ready for parsistance
            if (updatedSocialShare_Blogs.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Blogs.Attach(updatedSocialShare_Blogs);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_Blogs, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Blogs updated!");

            //Apply business workflow
            OnSocialShare_BlogsUpdated(updatedSocialShare_Blogs);
            OnSocialShare_BlogsSaved(updatedSocialShare_Blogs);

        }

        
        internal void DeleteSocialShare_Blogs(SocialShare_Blogs socialShare_BlogsToBeDeleted)
        {
            //Validate Input
            if (socialShare_BlogsToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_BlogsToBeDeleted"));

            // Validate Primary key value
            if (socialShare_BlogsToBeDeleted.BlogId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_BlogsToBeDeleted"));

            OnSocialShare_BlogsSaving(socialShare_BlogsToBeDeleted);
            OnSocialShare_BlogsDeleting(socialShare_BlogsToBeDeleted);

            if (socialShare_BlogsToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_Blogs.Attach(socialShare_BlogsToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_BlogsToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_Blogs deleted!");
            
            OnSocialShare_BlogsDeleted(socialShare_BlogsToBeDeleted);
            OnSocialShare_BlogsSaved(socialShare_BlogsToBeDeleted);

        }

        internal void DeleteSocialShare_Blogs(List<int> blogIdsToDelete)
        {
            //Validate Input
            foreach (int blogId in blogIdsToDelete)
                if (blogId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("blogIdsToDelete"));

            List<SocialShare_Blogs> socialShare_BlogssToBeDeleted = new List<SocialShare_Blogs>();

            foreach (int blogId in blogIdsToDelete)
            {
                SocialShare_Blogs socialShare_Blogs = new SocialShare_Blogs { BlogId = blogId };
                _socialShareDatabaseContext.SocialShare_Blogs.Attach(socialShare_Blogs);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Blogs, System.Data.EntityState.Deleted);
                socialShare_BlogssToBeDeleted.Add(socialShare_Blogs);
                OnSocialShare_BlogsDeleting(socialShare_Blogs);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != blogIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_Blogs records have not been deleted.");
            foreach (SocialShare_Blogs socialShare_BlogsToBeDeleted in socialShare_BlogssToBeDeleted)
                OnSocialShare_BlogsDeleted(socialShare_BlogsToBeDeleted);
        }

        #endregion
	
	}
}
