//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_Forum_CategoriesBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_Forum_CategoriesBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_Forum_CategoriesBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_Forum_CategoriesSaving(SocialShare_Forum_Categories socialShare_Forum_Categories);

        partial void OnSocialShare_Forum_CategoriesCreating(SocialShare_Forum_Categories socialShare_Forum_Categories);
        partial void OnSocialShare_Forum_CategoriesCreated(SocialShare_Forum_Categories socialShare_Forum_Categories);

        partial void OnSocialShare_Forum_CategoriesUpdating(SocialShare_Forum_Categories socialShare_Forum_Categories);
        partial void OnSocialShare_Forum_CategoriesUpdated(SocialShare_Forum_Categories socialShare_Forum_Categories);

        partial void OnSocialShare_Forum_CategoriesSaved(SocialShare_Forum_Categories socialShare_Forum_Categories);

        partial void OnSocialShare_Forum_CategoriesDeleting(SocialShare_Forum_Categories socialShare_Forum_Categories);
        partial void OnSocialShare_Forum_CategoriesDeleted(SocialShare_Forum_Categories socialShare_Forum_Categories);


        #endregion

        #region Get Methods

        internal SocialShare_Forum_Categories GetSocialShare_Forum_CategoriesByCategoryId(int categoryId)
        {
            //Validate Input
            if (categoryId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("categoryId"));
            
            return (_socialShareDatabaseContext.SocialShare_Forum_Categories.FirstOrDefault(socialShare_Forum_Categories => socialShare_Forum_Categories.CategoryId == categoryId));
        }
			
				
        
        internal List<SocialShare_Forum_Categories> GetAllSocialShare_Forum_Categories()
        {
            return _socialShareDatabaseContext.SocialShare_Forum_Categories.ToList();
        }

        
        internal List<SocialShare_Forum_Categories> GetAllSocialShare_Forum_CategoriesPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "CategoryId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_Forum_Categories in 
                        _socialShareDatabaseContext.SocialShare_Forum_Categories
                        .DynamicOrderBy(orderBy)
                    select socialShare_Forum_Categories
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Forum_Categories(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_Forum_Categories.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_Forum_Categories(SocialShare_Forum_Categories newSocialShare_Forum_Categories)
        {
            // Validate Parameters
            if (newSocialShare_Forum_Categories == null)
                throw (new ArgumentNullException("newSocialShare_Forum_Categories"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_Forum_Categories.CategoryId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_Forum_Categories"));
			*/
			
            // Apply business rules
            OnSocialShare_Forum_CategoriesSaving(newSocialShare_Forum_Categories);
            OnSocialShare_Forum_CategoriesCreating(newSocialShare_Forum_Categories);

            if (newSocialShare_Forum_Categories.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Forum_Categories.Attach(newSocialShare_Forum_Categories);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_Forum_Categories, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Forum_Categories created!");

            // Apply business workflow
            OnSocialShare_Forum_CategoriesCreated(newSocialShare_Forum_Categories);
            OnSocialShare_Forum_CategoriesSaved(newSocialShare_Forum_Categories);

            return newSocialShare_Forum_Categories.CategoryId;
        }

        
        internal void UpdateSocialShare_Forum_Categories(SocialShare_Forum_Categories updatedSocialShare_Forum_Categories)
        {
            // Validate Parameters
            if (updatedSocialShare_Forum_Categories == null)
                throw (new ArgumentNullException("updatedSocialShare_Forum_Categories"));

            // Validate Primary key value
            if (updatedSocialShare_Forum_Categories.CategoryId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_Forum_Categories"));

            // Apply business rules
            OnSocialShare_Forum_CategoriesSaving(updatedSocialShare_Forum_Categories);
            OnSocialShare_Forum_CategoriesUpdating(updatedSocialShare_Forum_Categories);

            //attaching and making ready for parsistance
            if (updatedSocialShare_Forum_Categories.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Forum_Categories.Attach(updatedSocialShare_Forum_Categories);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_Forum_Categories, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Forum_Categories updated!");

            //Apply business workflow
            OnSocialShare_Forum_CategoriesUpdated(updatedSocialShare_Forum_Categories);
            OnSocialShare_Forum_CategoriesSaved(updatedSocialShare_Forum_Categories);

        }

        
        internal void DeleteSocialShare_Forum_Categories(SocialShare_Forum_Categories socialShare_Forum_CategoriesToBeDeleted)
        {
            //Validate Input
            if (socialShare_Forum_CategoriesToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_Forum_CategoriesToBeDeleted"));

            // Validate Primary key value
            if (socialShare_Forum_CategoriesToBeDeleted.CategoryId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_Forum_CategoriesToBeDeleted"));

            OnSocialShare_Forum_CategoriesSaving(socialShare_Forum_CategoriesToBeDeleted);
            OnSocialShare_Forum_CategoriesDeleting(socialShare_Forum_CategoriesToBeDeleted);

            if (socialShare_Forum_CategoriesToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_Forum_Categories.Attach(socialShare_Forum_CategoriesToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Forum_CategoriesToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_Forum_Categories deleted!");
            
            OnSocialShare_Forum_CategoriesDeleted(socialShare_Forum_CategoriesToBeDeleted);
            OnSocialShare_Forum_CategoriesSaved(socialShare_Forum_CategoriesToBeDeleted);

        }

        internal void DeleteSocialShare_Forum_Categories(List<int> categoryIdsToDelete)
        {
            //Validate Input
            foreach (int categoryId in categoryIdsToDelete)
                if (categoryId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("categoryIdsToDelete"));

            List<SocialShare_Forum_Categories> socialShare_Forum_CategoriessToBeDeleted = new List<SocialShare_Forum_Categories>();

            foreach (int categoryId in categoryIdsToDelete)
            {
                SocialShare_Forum_Categories socialShare_Forum_Categories = new SocialShare_Forum_Categories { CategoryId = categoryId };
                _socialShareDatabaseContext.SocialShare_Forum_Categories.Attach(socialShare_Forum_Categories);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Forum_Categories, System.Data.EntityState.Deleted);
                socialShare_Forum_CategoriessToBeDeleted.Add(socialShare_Forum_Categories);
                OnSocialShare_Forum_CategoriesDeleting(socialShare_Forum_Categories);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != categoryIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_Forum_Categories records have not been deleted.");
            foreach (SocialShare_Forum_Categories socialShare_Forum_CategoriesToBeDeleted in socialShare_Forum_CategoriessToBeDeleted)
                OnSocialShare_Forum_CategoriesDeleted(socialShare_Forum_CategoriesToBeDeleted);
        }

        #endregion
	
	}
}
