//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_MemberProfilesBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_MemberProfilesBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_MemberProfilesBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_MemberProfilesSaving(SocialShare_MemberProfiles socialShare_MemberProfiles);

        partial void OnSocialShare_MemberProfilesCreating(SocialShare_MemberProfiles socialShare_MemberProfiles);
        partial void OnSocialShare_MemberProfilesCreated(SocialShare_MemberProfiles socialShare_MemberProfiles);

        partial void OnSocialShare_MemberProfilesUpdating(SocialShare_MemberProfiles socialShare_MemberProfiles);
        partial void OnSocialShare_MemberProfilesUpdated(SocialShare_MemberProfiles socialShare_MemberProfiles);

        partial void OnSocialShare_MemberProfilesSaved(SocialShare_MemberProfiles socialShare_MemberProfiles);

        partial void OnSocialShare_MemberProfilesDeleting(SocialShare_MemberProfiles socialShare_MemberProfiles);
        partial void OnSocialShare_MemberProfilesDeleted(SocialShare_MemberProfiles socialShare_MemberProfiles);


        #endregion

        #region Get Methods

        internal SocialShare_MemberProfiles GetSocialShare_MemberProfilesByProfileId(int profileId)
        {
            //Validate Input
            if (profileId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("profileId"));
            
            return (_socialShareDatabaseContext.SocialShare_MemberProfiles.FirstOrDefault(socialShare_MemberProfiles => socialShare_MemberProfiles.ProfileId == profileId));
        }
			
				
        
        internal List<SocialShare_MemberProfiles> GetAllSocialShare_MemberProfiles()
        {
            return _socialShareDatabaseContext.SocialShare_MemberProfiles.ToList();
        }

        
        internal List<SocialShare_MemberProfiles> GetAllSocialShare_MemberProfilesPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "ProfileId";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_MemberProfiles in 
                        _socialShareDatabaseContext.SocialShare_MemberProfiles
                        .DynamicOrderBy(orderBy)
                    select socialShare_MemberProfiles
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_MemberProfiles(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_MemberProfiles.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_MemberProfiles(SocialShare_MemberProfiles newSocialShare_MemberProfiles)
        {
            // Validate Parameters
            if (newSocialShare_MemberProfiles == null)
                throw (new ArgumentNullException("newSocialShare_MemberProfiles"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_MemberProfiles.ProfileId.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_MemberProfiles"));
			*/
			
            // Apply business rules
            OnSocialShare_MemberProfilesSaving(newSocialShare_MemberProfiles);
            OnSocialShare_MemberProfilesCreating(newSocialShare_MemberProfiles);

            if (newSocialShare_MemberProfiles.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_MemberProfiles.Attach(newSocialShare_MemberProfiles);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_MemberProfiles, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_MemberProfiles created!");

            // Apply business workflow
            OnSocialShare_MemberProfilesCreated(newSocialShare_MemberProfiles);
            OnSocialShare_MemberProfilesSaved(newSocialShare_MemberProfiles);

            return newSocialShare_MemberProfiles.ProfileId;
        }

        
        internal void UpdateSocialShare_MemberProfiles(SocialShare_MemberProfiles updatedSocialShare_MemberProfiles)
        {
            // Validate Parameters
            if (updatedSocialShare_MemberProfiles == null)
                throw (new ArgumentNullException("updatedSocialShare_MemberProfiles"));

            // Validate Primary key value
            if (updatedSocialShare_MemberProfiles.ProfileId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_MemberProfiles"));

            // Apply business rules
            OnSocialShare_MemberProfilesSaving(updatedSocialShare_MemberProfiles);
            OnSocialShare_MemberProfilesUpdating(updatedSocialShare_MemberProfiles);

            //attaching and making ready for parsistance
            if (updatedSocialShare_MemberProfiles.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_MemberProfiles.Attach(updatedSocialShare_MemberProfiles);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_MemberProfiles, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_MemberProfiles updated!");

            //Apply business workflow
            OnSocialShare_MemberProfilesUpdated(updatedSocialShare_MemberProfiles);
            OnSocialShare_MemberProfilesSaved(updatedSocialShare_MemberProfiles);

        }

        
        internal void DeleteSocialShare_MemberProfiles(SocialShare_MemberProfiles socialShare_MemberProfilesToBeDeleted)
        {
            //Validate Input
            if (socialShare_MemberProfilesToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_MemberProfilesToBeDeleted"));

            // Validate Primary key value
            if (socialShare_MemberProfilesToBeDeleted.ProfileId.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_MemberProfilesToBeDeleted"));

            OnSocialShare_MemberProfilesSaving(socialShare_MemberProfilesToBeDeleted);
            OnSocialShare_MemberProfilesDeleting(socialShare_MemberProfilesToBeDeleted);

            if (socialShare_MemberProfilesToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_MemberProfiles.Attach(socialShare_MemberProfilesToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_MemberProfilesToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_MemberProfiles deleted!");
            
            OnSocialShare_MemberProfilesDeleted(socialShare_MemberProfilesToBeDeleted);
            OnSocialShare_MemberProfilesSaved(socialShare_MemberProfilesToBeDeleted);

        }

        internal void DeleteSocialShare_MemberProfiles(List<int> profileIdsToDelete)
        {
            //Validate Input
            foreach (int profileId in profileIdsToDelete)
                if (profileId.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("profileIdsToDelete"));

            List<SocialShare_MemberProfiles> socialShare_MemberProfilessToBeDeleted = new List<SocialShare_MemberProfiles>();

            foreach (int profileId in profileIdsToDelete)
            {
                SocialShare_MemberProfiles socialShare_MemberProfiles = new SocialShare_MemberProfiles { ProfileId = profileId };
                _socialShareDatabaseContext.SocialShare_MemberProfiles.Attach(socialShare_MemberProfiles);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_MemberProfiles, System.Data.EntityState.Deleted);
                socialShare_MemberProfilessToBeDeleted.Add(socialShare_MemberProfiles);
                OnSocialShare_MemberProfilesDeleting(socialShare_MemberProfiles);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != profileIdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_MemberProfiles records have not been deleted.");
            foreach (SocialShare_MemberProfiles socialShare_MemberProfilesToBeDeleted in socialShare_MemberProfilessToBeDeleted)
                OnSocialShare_MemberProfilesDeleted(socialShare_MemberProfilesToBeDeleted);
        }

        #endregion
	
	}
}
