//------------------------------------------------------------------------------
// <auto-generated>
//
// ***************** Copyright Notice *****************
// 
// This code is licensed under Microsoft Public License (Ms-PL). 
// You are free to use, modify and distribute any portion of this code. 
// The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:
//
// =======================================================
//   
// Architecture Designed and Implemented By:
// Shahriar Iqbal Chowdhury
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Dynamic;
using SocialShare.BusinessEntities;
using SocialShare.DataAccessLayer;
using SocialShare.Helpers;

namespace SocialShare.BusinessLogicLayer
{   
	internal partial class SocialShare_MembersBLL
	{
		#region Constructors, Dependency and Partial Method Declaration

        public SocialShare_MembersBLL() : this(new SocialShareDatabaseContext()) { }

        public SocialShare_MembersBLL(SocialShareDatabaseContext socialShareDatabaseContext)
        {
            _socialShareDatabaseContext = socialShareDatabaseContext;
        }

        SocialShareDatabaseContext _socialShareDatabaseContext;

        public void Dispose()
        {
            if (_socialShareDatabaseContext != null)
            {
                _socialShareDatabaseContext.Dispose();
                _socialShareDatabaseContext = null;
            }
            
            GC.SuppressFinalize(this);
        }

        partial void OnSocialShare_MembersSaving(SocialShare_Members socialShare_Members);

        partial void OnSocialShare_MembersCreating(SocialShare_Members socialShare_Members);
        partial void OnSocialShare_MembersCreated(SocialShare_Members socialShare_Members);

        partial void OnSocialShare_MembersUpdating(SocialShare_Members socialShare_Members);
        partial void OnSocialShare_MembersUpdated(SocialShare_Members socialShare_Members);

        partial void OnSocialShare_MembersSaved(SocialShare_Members socialShare_Members);

        partial void OnSocialShare_MembersDeleting(SocialShare_Members socialShare_Members);
        partial void OnSocialShare_MembersDeleted(SocialShare_Members socialShare_Members);


        #endregion

        #region Get Methods

        internal SocialShare_Members GetSocialShare_MembersByMember_Id(int member_Id)
        {
            //Validate Input
            if (member_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("member_Id"));
            
            return (_socialShareDatabaseContext.SocialShare_Members.FirstOrDefault(socialShare_Members => socialShare_Members.Member_Id == member_Id));
        }
			
				
        
        internal List<SocialShare_Members> GetAllSocialShare_Members()
        {
            return _socialShareDatabaseContext.SocialShare_Members.ToList();
        }

        
        internal List<SocialShare_Members> GetAllSocialShare_MembersPaged(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            if (string.IsNullOrEmpty(orderBy))
                orderBy = "Member_Id";
				
			if (startRowIndex < 0) 
				throw (new ArgumentOutOfRangeException("startRowIndex"));
				
			if (maximumRows < 0) 
				throw (new ArgumentOutOfRangeException("maximumRows"));
			
            return (
                    from socialShare_Members in 
                        _socialShareDatabaseContext.SocialShare_Members
                        .DynamicOrderBy(orderBy)
                    select socialShare_Members
                    )
                    .Skip(startRowIndex)
                    .Take(maximumRows)
                    .ToList();
        }

        internal int GetTotalCountForAllSocialShare_Members(string orderBy = default(string), int startRowIndex = default(int), int maximumRows = default(int))
        {
            return _socialShareDatabaseContext.SocialShare_Members.Count();
        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        
        internal virtual int CreateNewSocialShare_Members(SocialShare_Members newSocialShare_Members)
        {
            // Validate Parameters
            if (newSocialShare_Members == null)
                throw (new ArgumentNullException("newSocialShare_Members"));

			/*
            
			// Validate Primary key value
            if (newSocialShare_Members.Member_Id.IsInvalidKey() == false)
                throw (new ArgumentOutOfRangeException("newSocialShare_Members"));
			*/
			
            // Apply business rules
            OnSocialShare_MembersSaving(newSocialShare_Members);
            OnSocialShare_MembersCreating(newSocialShare_Members);

            if (newSocialShare_Members.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Members.Attach(newSocialShare_Members);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(newSocialShare_Members, EntityState.Added);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Members created!");

            // Apply business workflow
            OnSocialShare_MembersCreated(newSocialShare_Members);
            OnSocialShare_MembersSaved(newSocialShare_Members);

            return newSocialShare_Members.Member_Id;
        }

        
        internal void UpdateSocialShare_Members(SocialShare_Members updatedSocialShare_Members)
        {
            // Validate Parameters
            if (updatedSocialShare_Members == null)
                throw (new ArgumentNullException("updatedSocialShare_Members"));

            // Validate Primary key value
            if (updatedSocialShare_Members.Member_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("updatedSocialShare_Members"));

            // Apply business rules
            OnSocialShare_MembersSaving(updatedSocialShare_Members);
            OnSocialShare_MembersUpdating(updatedSocialShare_Members);

            //attaching and making ready for parsistance
            if (updatedSocialShare_Members.EntityState == EntityState.Detached)
                _socialShareDatabaseContext.SocialShare_Members.Attach(updatedSocialShare_Members);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(updatedSocialShare_Members, System.Data.EntityState.Modified);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No socialShare_Members updated!");

            //Apply business workflow
            OnSocialShare_MembersUpdated(updatedSocialShare_Members);
            OnSocialShare_MembersSaved(updatedSocialShare_Members);

        }

        
        internal void DeleteSocialShare_Members(SocialShare_Members socialShare_MembersToBeDeleted)
        {
            //Validate Input
            if (socialShare_MembersToBeDeleted == null)
                throw (new ArgumentNullException("socialShare_MembersToBeDeleted"));

            // Validate Primary key value
            if (socialShare_MembersToBeDeleted.Member_Id.IsInvalidKey())
                throw (new ArgumentOutOfRangeException("socialShare_MembersToBeDeleted"));

            OnSocialShare_MembersSaving(socialShare_MembersToBeDeleted);
            OnSocialShare_MembersDeleting(socialShare_MembersToBeDeleted);

            if (socialShare_MembersToBeDeleted.EntityState == EntityState.Detached)
               _socialShareDatabaseContext.SocialShare_Members.Attach(socialShare_MembersToBeDeleted);
            _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_MembersToBeDeleted, System.Data.EntityState.Deleted);
            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows == 0) 
                throw new InvalidOperationException("No SocialShare_Members deleted!");
            
            OnSocialShare_MembersDeleted(socialShare_MembersToBeDeleted);
            OnSocialShare_MembersSaved(socialShare_MembersToBeDeleted);

        }

        internal void DeleteSocialShare_Members(List<int> member_IdsToDelete)
        {
            //Validate Input
            foreach (int member_Id in member_IdsToDelete)
                if (member_Id.IsInvalidKey())
                    throw (new ArgumentOutOfRangeException("member_IdsToDelete"));

            List<SocialShare_Members> socialShare_MemberssToBeDeleted = new List<SocialShare_Members>();

            foreach (int member_Id in member_IdsToDelete)
            {
                SocialShare_Members socialShare_Members = new SocialShare_Members { Member_Id = member_Id };
                _socialShareDatabaseContext.SocialShare_Members.Attach(socialShare_Members);
                _socialShareDatabaseContext.ObjectStateManager.ChangeObjectState(socialShare_Members, System.Data.EntityState.Deleted);
                socialShare_MemberssToBeDeleted.Add(socialShare_Members);
                OnSocialShare_MembersDeleting(socialShare_Members);
            }

            int numberOfAffectedRows = _socialShareDatabaseContext.SaveChanges();
            if (numberOfAffectedRows != member_IdsToDelete.Count) 
                throw new InvalidOperationException("One or more socialShare_Members records have not been deleted.");
            foreach (SocialShare_Members socialShare_MembersToBeDeleted in socialShare_MemberssToBeDeleted)
                OnSocialShare_MembersDeleted(socialShare_MembersToBeDeleted);
        }

        #endregion
	
	}
}
