﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Configuration;
using System.Web;

namespace Utilities
{
    public class SiteSettings
    {
        public static String FileUploadRelativePath
        {
            get
            {
                return WebConfigurationManager.AppSettings["_FileUploadPath"].ToString();
            }
        }
        public static String FileUploadAbsolutePath
        {
            get
            {
                return HttpContext.Current.Server.MapPath(WebConfigurationManager.AppSettings["_FileUploadPath"].ToString());
            }
        }

        public static String CompanyName
        {
            get
            {
                return "Social Share";
            }
        }

        public static string BaseUrl
        {
            get
            {
                string orginalUrl = HttpContext.Current.Request.Url.AbsoluteUri;
                if (HttpContext.Current.Request.Url.Query.Length > 0)
                    orginalUrl = orginalUrl.Replace(HttpContext.Current.Request.Url.Query, string.Empty);

                return orginalUrl.Replace(HttpContext.Current.Request.Url.AbsolutePath, string.Empty) + ((HttpContext.Current.Request.ApplicationPath == "/" ? "" : HttpContext.Current.Request.ApplicationPath)) + '/';
            }
        }
    }

    public enum ForumStatus
    {
        UnPublished = 0,
        Closed=1,
        Deleted=2,
        Reported=3,
        Deactivated=4,
        Published=5
    }

    public enum BlogStatus
    {
        UnPublished = 0,
        Published = 1,
        Deleted = 2,
        Reported = 3,
        Deactivated = 4,
        Closed = 5
    }

    public enum CmsType
    {
        Home=1,
        PrivacyStatement=2,
        Terms_Condition=3,
        SiteMap=4,
        MemberLanding=5

    }
}
