﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SocialShare.MVC.Domain.Blog
{
    public interface IBlogPostRepository
    {
        /// <summary>
        /// Find a blog post by given blog post id
        /// </summary>
        /// <param name="_id">id of blog post</param>
        /// <returns>a blog post</returns>
        BlogPost Find(Int32 _id);

        /// <summary>
        /// Finds all blog posts.
        /// </summary>
        /// <returns>All blog posts.</returns>
        IList<BlogPost> FindAll();

        /// <summary>
        /// Saves given blog post
        /// </summary>
        /// <param name="_post">blog post to save</param>
        void Store(BlogPost _post);
    }
}
