﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SocialShare.MVC.Domain.Forum
{
    interface IForumPostRepository
    {
        /// <summary>
        /// Find a blog post by given forum post id
        /// </summary>
        /// <param name="_id">id of forum post</param>
        /// <returns>a blog post</returns>
        ForumPost Find(Int32 _id);

        /// <summary>
        /// Finds all forum posts.
        /// </summary>
        /// <returns>All forum posts.</returns>
        IList<ForumPost> FindAll();

        /// <summary>
        /// Saves given forum post
        /// </summary>
        /// <param name="_post">forum post to save</param>
        void Store(ForumPost _post);
    }
}
