﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;

namespace SocialShare.MVC.Domain.Shared
{
    public class Post
    {
        public Int32 PostId
        {
            get;
            set;
        }

        [Required(ErrorMessage = "Please enter a Post Title")]
        [StringLength(20, ErrorMessage = "Title is too long")]
        public String Title
        {
            get;
            set;
        }

        [Required(ErrorMessage = "Please enter the Date of the Post")]
        public DateTime PostDate
        {
            get;
            set;
        }

        public Boolean IsActive
        {
            get;
            set;
        }

        public Boolean IsPublished
        {
            get;
            set;
        }

        public Int32 PostedBy
        {
            get;
            set;
        }
    }
}
